;******************************************************************************
;+--------------------------------------------------------------------------+**
;|                            ****                                          |**
;|                            ****                                          |**
;|                            ******o***                                    |**
;|                      ********_;/_****                                    |**
;|                      ***** /_;_/ ****                                    |**
;|                       ** ** (__/ ****                                    |**
;|                           *********                                      |**
;|                            ****                                          |**
;|                            ***                                           |**
;|                                                                          |**
;|         Copyright (c) 1998-2014 Texas Instruments Incorporated           |**
;|                        ALL RIGHTS RESERVED                               |**
;|                                                                          |**
;| Permission is hereby granted to licensees of Texas Instruments           |**
;| Incorporated (TI) products to use this computer program for the sole     |**
;| purpose of implementing a licensee product based on TI products.         |**
;| No other rights to reproduce, use, or disseminate this computer          |**
;| program, whether in part or in whole, are granted.                       |**
;|                                                                          |**
;| TI makes no representation or warranties with respect to the             |**
;| performance of this computer program, and specifically disclaims         |**
;| any responsibility for any damages, special or consequential,            |**
;| connected with the use of this program.                                  |**
;|                                                                          |**
;+--------------------------------------------------------------------------+**
;******************************************************************************
;  (C) Copyright 2014, Texas Instruments, Inc
;
;	Version		Description								Author
; 	0.1     	Created						Fabian Fischer, Karthik Bandi

CALL .macro func
	jal		RET_ADDR0, func
	.endm

RET .macro
	JMP		RET_ADDR0
	.endm

CALL1 .macro func
	jal		RET_ADDR1, func
	.endm

RET1 .macro
	JMP		RET_ADDR1
	.endm

CALL2 .macro func
	jal		RET_ADDR2, func
	.endm

RET2 .macro
	JMP		RET_ADDR2
	.endm


WAIT .macro delay
	lsr delay, delay, 1
l?:	sub delay,delay,1
	qblt l?,delay,0
	.endm

M_RESET_CYCLCNT .macro temp1_32, temp2_32
	.if $defined(PRU0)
	LDI32	temp1_32, ICSS_PRU0_CNTL_BASE
	.else
	LDI32 	temp1_32, ICSS_PRU1_CNTL_BASE
	.endif
	LBBO	&temp2_32, temp1_32, PRUx_CNTL_CONTROL_OFFSET, 4
	SET		temp2_32, temp2_32, 3		; enable cycle counter
	SBBO	&temp2_32, temp1_32, PRUx_CNTL_CYCLE_COUNT_OFFSET, 4	; clear cycle counter
	SBBO	&temp2_32, temp1_32, PRUx_CNTL_CONTROL_OFFSET, 4
	.endm

M_XMT_GET_FIFO_LEVEL .macro TEMP1_32, TX_CNT_16, FIFO_LEVEL_8
	.if $defined(PRU0)
	LDI32	TEMP1_32, ICSS_CNTL0_BASE
	.else
	LDI32	TEMP1_32, ICSS_CNTL1_BASE
	.endif
	LBBO	&TEMP1_32.w0, TEMP1_32, PRUx_CNTL_CYCLE_COUNT_OFFSET, 2	; read out current cycle counter
	LSR		TEMP1_32.w0, TEMP1_32.w0, 4	; cycle counter divided by 16 --> total number of bytes transmitted
	ADD		TEMP1_32.w2, TX_CNT_16, PREAMBLE_COUNT
	SUB		FIFO_LEVEL_8, TEMP1_32.w2, TEMP1_32.w0	; FIFO level = bytes pushed into TX fifo - cycle counter bytes
	.endm


READ_CYCLCNT .macro dst
	lbco		&dst, PRU_CTRL_CONST, PRU_CYCLCNT, 4
	.endm

READ_IEPCNT .macro dst
	lbco		&dst, IEP_CONST, IEP_CNT, 4
	.endm


NOP .macro
	and			r0, r0, r0
	.endm

NOP_2 .macro
	loop			l?, 2
l?:
	.endm

