; Copyright (C) 2016 Texas Instruments Incorporated - http:;www.ti.com/
;
; Redistribution and use in source and binary forms, with or without
; modification, are permitted provided that the following conditions
; are met:
;
; Redistributions of source code must retain the above copyright
; notice, this list of conditions and the following disclaimer.
;
; notice, this list of conditions and the following disclaimer in the
; documentation and/or other materials provided with the
; distribution.
;
; Neither the name of Texas Instruments Incorporated nor the names of
; its contributors may be used to endorse or promote products derived
; from this software without specific prior written permission.
;
; THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
; "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
; LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
; A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
; OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
; LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
; DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
; THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
; (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
; OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;*****************************************************************************/
; file:   appl_defines.inc
;
; brief:  {}
;
;
;  (C) Copyright 2016, Texas Instruments, Inc
;
;  author     {Thomas Mauer}
;
;  version    0.1     Created
;
	.if ! $defined( __appl_defines_inc)
	.define "1", __appl_defines_inc

	.asg 		R29.w0, RET_ADDR0
	.asg		R29.w2, RET_ADDR1
;	.asg		R28.w2, RET_ADDR2

	.asg		R28.b0, RCV_STATUS_REG

	.asg		R18, TEMP_REG_5
	.asg		R17, TEMP_REG_4
	.asg		R16, TEMP_REG_3
	.asg		R15, TEMP_REG_2
	.asg		R14, TEMP_REG_1

; definition of scratch pad IDs
BANK0			.set	10
BANK1			.set	11
BANK2			.set	12
; definition of RX L2 bank ID
RCV_L2_BANK0_ID	.set	20
RCV_L2_BANK1_ID	.set	21

; protocol specific defines
RXL2_LEVEL_START	.set	20		; #of bytes in L2 bank before receive first block gets executed
	.asg				R3.b3, RXL2_SFD_REGISTER
	.asg				R0.b3, REMAINING_BYTES_CNT

; definition of bits in RCV_STATUS_REG
RCV_ACTIVE_FLAG			.set	0		; flag is set once a valid frame is getting received
RCV_HOST_PORT_FLAG		.set	1		; flag is set when the received frame has to be copied to the host queue (port 2)
RCV_L2_CURRENT_WORKING_BANK .set	2	; flag to track L2 receive
RCV_TS_HIGH_UPDATE_FLAG	.set 	6		; flag is set when IEP wraparound event handler is called; FB was not called yet but R18.b0 is not 0
RCV_EOF_EVENT_FLAG		.set	7		; flag is set by event handler when EOF event has been detected

RANGE_R2_R18	.set	(4*17)
RANGE_R2_R13	.set	(4*12)
RANGE_R2_R9		.set	(4*8)
RANGE_R19_R26	.set	(4*8)

; parameter in ICCS shared memory
PHY_STATUS_OFFSET				.set	0x0002		; .field16
MDIO_PHY_CONFIG_OFFSET			.set	0x0004		; .field32

; statistics
STAT_RCV_P0						.set	0x0020		; .field16
STAT_RCV_P1						.set	0x0022		; .field16
;STAT_TX_P0						.set	0x0024		; .field16
;STAT_TX_P1						.set	0x0026		; .field16
STAT_CRCERR_P0					.set	0x0028		; .field16
STAT_CRCERR_P1					.set	0x002A		; .field16
STAT_RCV_OVERFLOW_P0			.set	0x002C		; .field16
STAT_RCV_OVERFLOW_P1			.set	0x002E		; .field16

; IEP counter values in PRU Local Memory
IEP_CNT_HIGH_PRU0					.set	0x0040		; .field32
IEP_CNT_HIGH_PRU1					.set	0x0044		; .field32

; IEP counters and Header offset inside packet block in OCMC
IEP_LOW_COUNTER_OFFSET			.set	0x4			; .field32
IEP_HIGH_COUNTER_OFFSET			.set	0x8			; .field32
PACKET_DESCRIPTOR_OFFSET		.set	0x0			; .field32

; Header bits
TIMESTAMP_BIT					.set	15
PORT_BIT						.set	27			; 0 means PRU0 or Port0 and 1 means PRU1 or Port1

; read/write pointer of port queues
PORT2_RXPRU0_QUEUE_POINTER			.set	0x0100	; handled by PRU0
PORT2_RXPRU1_QUEUE_POINTER			.set	0x0104	; handled by PRU1

; buffer descriptor base address: 32 buffer descriptors per queue
BUFFER_DESC_COUNT					.set 	500
PORT2_RXPRU0_BUFFER_DESC			.set	0x0120
PORT2_RXPRU1_BUFFER_DESC			.set	(PORT2_RXPRU0_BUFFER_DESC + BUFFER_DESC_COUNT*4)
PORT2_RXPRU1_BUFFER_DESC_END		.set	(PORT2_RXPRU1_BUFFER_DESC + BUFFER_DESC_COUNT*4)

; buffer descriptor usage
; .w2 --> length
; .t0 --> frame error
BUFFER_DESC_FRAME_ERROR_FLAG		.set 	0

; .t4 --> CRC error in beckhoff format
; .t3 --> alignment error in beckhoff format
; .t5 --> bit 5 is not mentioned in beckhoff format but we are using it to indicate RX_ERR
CRC_ERROR_ESL_BIT				.set	4
ALIGNMENT_ERROR_ESL_BIT			.set	3
RX_ERR_ESL_BIT					.set	5

; .t0 --> RX_ERR in AM572x TRM
; .t6 --> ERROR_NIBBLE in AM572x TRM
; .t7 --> ERROR_CRC in AM572x TRM
RX_ERR_BIT							.set	0
ERROR_NIBBLE_BIT					.set	6
ERROR_CRC_BIT						.set	7

; frame queue base address in OCMC/L3 memory
BUFFER_SIZE							.set	32		;size of each queue entry in bytes
QUEUE_COUNT							.set	BUFFER_DESC_COUNT	;number of queue entries
TOTAL_BUFFER_SIZE					.set	(BUFFER_SIZE * QUEUE_COUNT)
PORT2_RXPRU0_BUFFER_ADDR				.set	0x0000
PORT2_RXPRU1_BUFFER_ADDR				.set	(PORT2_RXPRU0_BUFFER_ADDR +  BUFFER_SIZE*QUEUE_COUNT)
PORT2_RXPRU1_BUFFER_ADDR_END			.set	(PORT2_RXPRU1_BUFFER_ADDR +  BUFFER_SIZE*QUEUE_COUNT)

; MII receive descriptor
MII_RCV_DESC	.struct
host_buffer_ptr			.field 16	; host queue buffer base pointer
rcv_byte_cnt			.field 16	; frame length counter
				.endstruct
MII_RCV	.sassign R27, MII_RCV_DESC

SHIFT_MII_RCV_PARAMS	.set	0
;SHIFT_MII_XMT_PARAMS	.set	(30-(25-22))

PRU_ARM_EVENT0						.set	20
PRU_ARM_EVENT0_IRQ					.set	(0x20 | (PRU_ARM_EVENT0 - 16))
PRU0_PRU1_WRAPAROUND_EVENT 			.set	26
PRU0_PRU1_WRAPAROUND_EVENT_IRQ 		.set	(0x20 | (PRU0_PRU1_WRAPAROUND_EVENT - 16))

	.endif ; of (__appl_defines_inc)


