/*
* Real-time Ethernet on PRU-ICSS
*
* TI design to demonstrate the multi-protocol digital position encoder
* master interface for EnDat 2.2, Hiperface DSL and BiSS
*
* Copyright (C) 2016 Texas Instruments Incorporated - http://www.ti.com/
 *
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
*
*    Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
*
*    Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the
 *    distribution.
*
*    Neither the name of Texas Instruments Incorporated nor the names of
*    its contributors may be used to endorse or promote products derived
*    from this software without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
*  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/

#ifndef _RTE_APPL_DEF_H
#define _RTE_APPL_DEF_H

// slave specific configuration
#define	RTE_SLAVE_ADDRESS	0x12


// configuration parameters in ICCS shared memory
#define STATION_SLAVE_ADDRESS_OFFSET	0x0000		// .field8
#define PHY_STATUS_OFFSET				0x0002		// .field16
#define MDIO_PHY_CONFIG_OFFSET			0x0004		// .field32


// bus timing parameters
#define BUS_CYCLE_TIME					0x0030		// .field32
#define RT_WINDOW_OPEN					0x0034		// .field32
#define NRT_WINDOW_OPEN					0x0038		// .field32
#define NRT_LAST_TX						0x003C		// .field32


// TTS descriptor list
#define TTS_DESCRIPTOR_LIST				0x0200
#define TTS_FRAME_BUFFER				0x1000

#endif
